module Wizypay
  class BalanceReport < Resource
    class Line < Resource
      def date
        return nil unless super.present?
        Date.parse(super)
      end
    end

    def self.show(granularity, opts = {})
      raw = ApiClient.get('/balance_report', opts.merge(granularity: granularity))
      Collection.new(Line, raw[:data], raw[:meta])
    end

    def self.monthly(opts = {})
      show('month', opts)
    end

    def self.daily(opts = {})
      show('day', opts)
    end
  end
end
