module Wizypay
  class Beneficiary < Resource
    def self.where(q)
      raw = ApiClient.get('/beneficiaries', q)
      Collection.new(self, raw[:data], raw[:meta])
    end

    def self.all(q = {})
      where(q)
    end

    def self.find(id)
      new(ApiClient.get("/beneficiaries/#{id}")[:data])
    end

    def cards
      Collection.new(DebitCard, super['data'], super['meta'])
    end

    def save
      reinitialize ApiClient.put("/beneficiaries/#{id}", to_h)[:data]
    end
  end
end
