class Wizypay::Collection
  include Enumerable

  def initialize(klass, data, meta = {})
    @data = data.map {|h| klass.new(h)}
    @meta = meta || {}
  end

  def respond_to?(m)
    data.respond_to?(m) || meta.has_key?(m.to_s) || super
  end

  def method_missing(m, *args, &block)
    if data.respond_to?(m)
      data.send(m, *args, &block)
    elsif meta.has_key?(m.to_s)
      meta[m.to_s]
    else
      super
    end
  end

  private

  attr_reader :data, :meta
end
