module Wizypay
  class Merchant < Resource
    def self.where(q)
      raw = ApiClient.get('/merchants', q)
      Collection.new(self, raw[:data], raw[:meta])
    end

    def self.all(q = {})
      where(q)
    end

    def versions
      MerchantVersion.for(self)
    end

    def primary_ad
      Resource.new(super['data'])
    end

    def primary_ad_id
      super || primary_ad.id || ads.first.try(:id)
    end

    def ads
      Collection.new(Ad, super['data'], super['meta'])
    end

    def categories
      Collection.new(MerchantCategory, super['data'], super['meta'])
    end

    def network_updated_at
      return nil unless super.present?
      Time.parse(super)
    end
  end
end
