module Wizypay
  class MerchantVersion < Resource
    def self.for(merchant)
      for_id(merchant.id)
    end

    def self.for_id(merchant_id)
      raw = ApiClient.get("/merchants/#{merchant_id}/versions")
      Collection.new(self, raw[:data], raw[:meta])
    end

    def merchant
      Merchant.new(super['data'])
    end

    def created_at
      return nil unless super.present?
      Time.parse(super)
    end
  end
end
